$!
$! This procedure unpacks the PHP source distribution as a directory tree
$! under this file's current location and then adds to in the [.openvms...]
$! update tree for porting this version to VMS.
$!
$! The VMSTAR utility or equivalent is required to unpack the
$! the PHP source archive.
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Orient ourselves.
$!
$ proc = f$environment("PROCEDURE")
$ proc_name = f$parse(proc,,,"NAME")+f$parse(proc,,,"TYPE")+f$parse(proc,,,"VERSION")
$ proc_dir = f$extract(0,f$length(proc)-f$length(proc_name),proc)
$ original_directory = f$environment("DEFAULT")
$ on warning then goto proc_abort
$ on control_y then goto proc_abort
$ show symbol proc_dir
$ set default 'proc_dir'
$ acptype = f$getdvi("SYS$DISK:","ACPTYPE")
$ if acptype .lts. "F11V5" then write sys$output -
	"Warning! Attempt to unpack to non-ODS-5 disk."
$!
$! Locate files to unpack and utilities to do so.
$!
$ tar_search_spec = "sys$disk:[]php%4%4%7.tar;"
$ bck_search_spec = "sys$disk:[]php%4%4%7-ovmsroot.bck;"
$ if f$type(vmstar) .eqs. "" then gosub locate_vmstar
$ tar_source = f$search(tar_search_spec,1)
$ amb_tar_source = f$search(tar_search_spec,1)
$ if amb_tar_source .nes. "" .or. tar_source .eqs. "" then -
	gosub locate_tar_source
$!
$ bck_source = f$search(bck_search_spec,2)
$ amb_bck_source = f$search(bck_search_spec,2)
$ if amb_bck_source .nes. "" .or. bck_source .eqs. "" then -
	gosub locate_bck_source
$ rfm = f$file(bck_source,"RFM")
$ lrl = f$file(bck_source,"LRL")
$ if rfm .nes. "FIX"
$ then
$   write sys$output "Backup file has wrong record format, fixing..."
$   set file 'bck_source'/attribute=(RFM:FIX,LRL:32256)
$ else
$   if lrl .eq. 512
$   then
$       write sys$output "Backup file as 512 byte record size, fixing..."
$	set file 'bck_source'/attribute=(LRL:32256)
$   endif
$ endif
$!
$! upack the files.
$!
$ write sys$output "Unpacking tar file..."
$ vmstar xf 'tar_source'
$ subdir = f$search("PHP*.DIR;1")
$ if subdir .eqs. ""
$ then
$    write sys$output "Unpack of TAR file didn't make directory!"
$    goto abort
$ endif
$ dir_name = f$parse(subdir,,,"NAME")
$ create/dir [.'dir_name'.OpenVMS]/log
$ create/dir [.'dir_name'.httpd_update]/log
$ create/dir [.'dir_name'.sapi.osu]/log
$ write sys$output "Unpacking [.OpenVMS...] tree"
$ backup 'bck_source'/save [.'dir_name'...]/owner=parent
$!
$ Type sys$input
$ deck

Done.

To build php-cgi.exe image:
    1. @[.php-4^.4^.7.OpenVMS]set_root_logicals.
    2. set default php_root:[sapi.osu]
    3  @mms_actions.com

$ eod
$!
$ proc_abort:
$ set default 'original_directory'
$ exit
$!
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Ask user location of vmstar executable.
$!
$ locate_vmstar:
$ inquire ans "Enter file specification of VMSTAR executable, or return to exit"
$ if ans .eqs. "" then exit
$ vmstar_image = f$search(f$parse(ans,".exe"))
$ if vmstar_image .eqs. ""
$ then
$    write sys$output "Invalid or missing file: ", ans
$    goto locate_vmstar
$ endif
$! Stip version so known image will run if installed.
$ vmstar = "$" + f$extract(0,f$length(vmstar_image)-f$length( -
	f$parse(vmstar_image,,,"VERSION")),vmstar_image)
$ return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Ask user location of vmstar executable.
$!
$ locate_tar_source:
$ show symbol *tar*
$ inquire ans "Enter file specification of PHP 4.4.7 tar file"
$ if ans .eqs. "" then exit
$ vmstar_image = f$search(f$parse(ans))
$ if vmstar_image .eqs. ""
$ then
$    write sys$output "Invalid or missing file: ", ans
$    goto locate_tar_source
$ endif
$ return
$!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
$! Ask user location of backup save set for [.openvms...] sub-directory
$!
$ locate_bck_source:
$ show symbol *bck*
$ inquire ans "Enter file specification of PHP 4.4.7 backup save set
$ if ans .eqs. "" then exit
$ vmstar_image = f$search(f$parse(ans,".bck"))
$ if vmstar_image .eqs. ""
$ then
$    write sys$output "Invalid or missing file: ", ans
$    goto locate_bck_source
$ endif
$ return
